// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/ClusterBreakupReason.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_BREAKUP_REASON__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_BREAKUP_REASON__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'NOT_PROVIDED'.
enum
{
  etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__NOT_PROVIDED = 0
};

/// Constant 'CLUSTERING_PURPOSE_COMPLETED'.
enum
{
  etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__CLUSTERING_PURPOSE_COMPLETED = 1
};

/// Constant 'LEADER_MOVED_OUT_OF_CLUSTER_BOUNDING_BOX'.
enum
{
  etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__LEADER_MOVED_OUT_OF_CLUSTER_BOUNDING_BOX = 2
};

/// Constant 'JOINING_ANOTHER_CLUSTER'.
enum
{
  etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__JOINING_ANOTHER_CLUSTER = 3
};

/// Constant 'ENTERING_LOW_RISK_AREA_BASED_ON_MAPS'.
enum
{
  etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__ENTERING_LOW_RISK_AREA_BASED_ON_MAPS = 4
};

/// Constant 'RECEPTION_OF_CPM_CONTAINING_CLUSTER'.
enum
{
  etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__RECEPTION_OF_CPM_CONTAINING_CLUSTER = 5
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__MAX = 15
};

/// Struct defined in msg/ClusterBreakupReason in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__ClusterBreakupReason
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
  ///   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   vam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the reason why a cluster leader intends to break up the cluster.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 - `notProvided`                          - if the information is not provided,
  ///  * - 1 - `clusteringPurposeCompleted`           - if the cluster purpose has been completed,
  ///  * - 2 - `leaderMovedOutOfClusterBoundingBox`   - if the leader moved out of the cluster's bounding box,
  ///  * - 3 - `joiningAnotherCluster`                - if the cluster leader is about to join another cluster,
  ///  * - 4 - `enteringLowRiskAreaBasedOnMaps`       - if the cluster is entering an area idenrified as low risk based on the use of maps,
  ///  * - 5 - `receptionOfCpmContainingCluster`      - if the leader received a Collective Perception Message containing information about the same cluster.
  ///  * - 6 to 15                                    - are reserved for future use.
  ///  *
  ///  * @category: Cluster information
  ///  * @revision: Created in V2.1.1
  /// */
  /// ClusterBreakupReason ::= ENUMERATED {
  ///     notProvided                        (0),
  ///     clusteringPurposeCompleted         (1),
  ///     leaderMovedOutOfClusterBoundingBox (2),
  ///     joiningAnotherCluster              (3),
  ///     enteringLowRiskAreaBasedOnMaps     (4),
  ///     receptionOfCpmContainingCluster    (5),
  ///     max(15)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__ClusterBreakupReason;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__ClusterBreakupReason.
typedef struct etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__Sequence
{
  etsi_its_vam_ts_msgs__msg__ClusterBreakupReason * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_BREAKUP_REASON__STRUCT_H_
