// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/SafeDistanceIndication.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__SAFE_DISTANCE_INDICATION__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__SAFE_DISTANCE_INDICATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'subject_station'
#include "etsi_its_vam_ts_msgs/msg/detail/station_id__struct.h"
// Member 'safe_distance_indicator'
#include "etsi_its_vam_ts_msgs/msg/detail/safe_distance_indicator__struct.h"
// Member 'time_to_collision'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_tenth_of_second__struct.h"

/// Struct defined in msg/SafeDistanceIndication in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__SafeDistanceIndication
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
  ///   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   vam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF provides the safe distance indication of a traffic participant with other traffic participant(s).
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field subjectStation: optionally indicates one "other" traffic participant identified by its ITS-S.
  ///  *
  ///  * @field safeDistanceIndicator: indicates whether the distance between the ego ITS-S and the traffic participant(s) is safe.
  ///  * If subjectStation is present then it indicates whether the distance between the ego ITS-S and the traffic participant indicated in the component subjectStation is safe.
  ///  *
  ///  * @field timeToCollision: optionally indicated the time-to-collision calculated as sqrt(LaDi^2 + LoDi^2 + VDi^2/relative speed
  ///  * and represented in  the  nearest 100  ms. This component may be present only if subjectStation is present.
  ///  *
  ///  * @note: the abbreviations used are Lateral Distance (LaD),  Longitudinal Distance (LoD) and Vertical Distance (VD)
  ///  * and their respective  thresholds, Minimum  Safe  Lateral  Distance (MSLaD), Minimum  Safe  Longitudinal Distance  (MSLoD),  and  Minimum  Safe Vertical Distance (MSVD).
  ///  *
  ///  * @category: Traffic information, Kinematic information
  ///  * @revision: created in V2.1.1
  ///  */
  /// SafeDistanceIndication ::= SEQUENCE {
  ///     subjectStation           StationId OPTIONAL,
  ///     safeDistanceIndicator    SafeDistanceIndicator,
  ///     timeToCollision          DeltaTimeTenthOfSecond OPTIONAL,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_vam_ts_msgs__msg__StationId subject_station;
  bool subject_station_is_present;
  etsi_its_vam_ts_msgs__msg__SafeDistanceIndicator safe_distance_indicator;
  etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond time_to_collision;
  bool time_to_collision_is_present;
} etsi_its_vam_ts_msgs__msg__SafeDistanceIndication;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__SafeDistanceIndication.
typedef struct etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence
{
  etsi_its_vam_ts_msgs__msg__SafeDistanceIndication * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__SAFE_DISTANCE_INDICATION__STRUCT_H_
