// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/VruHighFrequencyContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_HIGH_FREQUENCY_CONTAINER__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_HIGH_FREQUENCY_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'heading'
// Member 'orientation'
#include "etsi_its_vam_ts_msgs/msg/detail/wgs84_angle__struct.h"
// Member 'speed'
#include "etsi_its_vam_ts_msgs/msg/detail/speed__struct.h"
// Member 'longitudinal_acceleration'
#include "etsi_its_vam_ts_msgs/msg/detail/longitudinal_acceleration__struct.h"
// Member 'curvature'
#include "etsi_its_vam_ts_msgs/msg/detail/curvature__struct.h"
// Member 'curvature_calculation_mode'
#include "etsi_its_vam_ts_msgs/msg/detail/curvature_calculation_mode__struct.h"
// Member 'yaw_rate'
#include "etsi_its_vam_ts_msgs/msg/detail/yaw_rate__struct.h"
// Member 'lateral_acceleration'
#include "etsi_its_vam_ts_msgs/msg/detail/lateral_acceleration__struct.h"
// Member 'vertical_acceleration'
#include "etsi_its_vam_ts_msgs/msg/detail/vertical_acceleration__struct.h"
// Member 'vru_lane_position'
#include "etsi_its_vam_ts_msgs/msg/detail/generalized_lane_position__struct.h"
// Member 'environment'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_environment__struct.h"
// Member 'movement_control'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_movement_control__struct.h"
// Member 'roll_angle'
#include "etsi_its_vam_ts_msgs/msg/detail/cartesian_angle__struct.h"
// Member 'device_usage'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_device_usage__struct.h"

/// Struct defined in msg/VruHighFrequencyContainer in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
  ///   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   vam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * @details VruHighFrequencyContainer
  ///  * The VRU HF container of the VAM contains potentially fast-changing status information of the VRU ITS-S.
  ///  * It includes the following components (setting indications are specified in clause 7.3.3 of TS 103 300-3):
  ///  *
  ///  * @field heading: heading and heading confidence of the originating VRU with regards to the true north.
  ///  * @field speed: speed in moving direction and speed confidence of the originating VRU.
  ///  * @field longitudinalAcceleration: longitudinal acceleration of the originating VRU.
  ///  * @field curvature: related to the actual trajectory of the originating VRU vehicle.
  ///           _(recommended for VRU Profile 2)_
  ///  * @field curvatureCalculationMode: indicates whether vehicle yaw-rate is used in the calculation of
  ///  *        the curvature of the VRU vehicle ITS-S that originates the VAM. _(recommended for VRU Profile 2)_
  ///  * @field yawRate: yaw rate of originating VRU vehicle. _(recommended for VRU Profile 2)_
  ///  * @field lateralAcceleration: originating VRU lateral acceleration in the street plane.
  ///  *        This field shall be present if the data is available at the originating ITS-S. _(recommended for VRU Profile 2)_
  ///  * @field verticalAcceleration: vertical acceleration of the originating VRU.
  ///  *        This field shall be present if the data is available at the originating ITS-S.
  ///  * @field vruLanePosition: lane position of the referencePosition of a VRU, which is either a VRU-specific non-traffic lane
  ///  *        or a standard traffic lane. This field shall be present if the data is available at the originating ITS-S.
  ///  * @field environment: provides contextual awareness of the VRU among other road users.
  ///  *        This field shall be present only if the data is available at the originating ITS-S.
  ///  * @field movementControl: indicates the mechanism used by the VRU to control the  longitudinal movement of the VRU vehicle.
  ///  *        This field shall be present only if the data is available at the originating ITS-S. _(recommended for VRU Profile 2)_
  ///  * @field orientation : complements the dimensions of the VRU vehicle by defining the angle of the VRU vehicle longitudinal
  ///  *        axis with regards to the WGS84 north. _(recommended for VRU Profile 2)_
  ///  * @field rollAngle: provides the angle and angle accuracy between the ground plane and the current orientation of a vehicle's
  ///  *        y-axis with respect to the ground plane about the x-axis according to the ISO 8855.
  ///  *        This field shall be present only if the data is available at the originating ITS-S. _(recommended for VRU Profile 2)_
  ///  * @field deviceUsage: provides indications from the personal device about the potential
  ///  *        activity of the VRU. This field shall be present only if the data is available at the originating ITS-S.
  ///  *        _(recommended for VRU Profile 1)_
  ///  *
  ///  * @category: VRU information
  ///  * @revision: V2.2.1
  ///  */
  ///     VruHighFrequencyContainer ::= SEQUENCE {
  ///         heading                  Wgs84Angle,
  ///         speed                    Speed,
  ///         longitudinalAcceleration LongitudinalAcceleration,
  ///         curvature                Curvature OPTIONAL,
  ///         curvatureCalculationMode CurvatureCalculationMode OPTIONAL,
  ///         yawRate                  YawRate OPTIONAL,
  ///         lateralAcceleration      LateralAcceleration OPTIONAL,
  ///         verticalAcceleration     VerticalAcceleration OPTIONAL,
  ///         vruLanePosition          GeneralizedLanePosition OPTIONAL,
  ///         environment              VruEnvironment OPTIONAL,
  ///         movementControl          VruMovementControl OPTIONAL,
  ///         orientation              Wgs84Angle OPTIONAL,
  ///         rollAngle                CartesianAngle OPTIONAL,
  ///         deviceUsage              VruDeviceUsage OPTIONAL,
  ///         ...
  ///     }
  /// ------------------------------------------------------------------------------
  etsi_its_vam_ts_msgs__msg__Wgs84Angle heading;
  etsi_its_vam_ts_msgs__msg__Speed speed;
  etsi_its_vam_ts_msgs__msg__LongitudinalAcceleration longitudinal_acceleration;
  etsi_its_vam_ts_msgs__msg__Curvature curvature;
  bool curvature_is_present;
  etsi_its_vam_ts_msgs__msg__CurvatureCalculationMode curvature_calculation_mode;
  bool curvature_calculation_mode_is_present;
  etsi_its_vam_ts_msgs__msg__YawRate yaw_rate;
  bool yaw_rate_is_present;
  etsi_its_vam_ts_msgs__msg__LateralAcceleration lateral_acceleration;
  bool lateral_acceleration_is_present;
  etsi_its_vam_ts_msgs__msg__VerticalAcceleration vertical_acceleration;
  bool vertical_acceleration_is_present;
  etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition vru_lane_position;
  bool vru_lane_position_is_present;
  etsi_its_vam_ts_msgs__msg__VruEnvironment environment;
  bool environment_is_present;
  etsi_its_vam_ts_msgs__msg__VruMovementControl movement_control;
  bool movement_control_is_present;
  etsi_its_vam_ts_msgs__msg__Wgs84Angle orientation;
  bool orientation_is_present;
  etsi_its_vam_ts_msgs__msg__CartesianAngle roll_angle;
  bool roll_angle_is_present;
  etsi_its_vam_ts_msgs__msg__VruDeviceUsage device_usage;
  bool device_usage_is_present;
} etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer.
typedef struct etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer__Sequence
{
  etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_HIGH_FREQUENCY_CONTAINER__STRUCT_H_
