// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/VruSpecificExteriorLights.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_SPECIFIC_EXTERIOR_LIGHTS__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_SPECIFIC_EXTERIOR_LIGHTS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__SIZE_BITS = 8
};

/// Constant 'BIT_INDEX_UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__BIT_INDEX_UNAVAILABLE = 0
};

/// Constant 'BIT_INDEX_BACK_FLASH_LIGHT'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__BIT_INDEX_BACK_FLASH_LIGHT = 1
};

/// Constant 'BIT_INDEX_HELMET_LIGHT'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__BIT_INDEX_HELMET_LIGHT = 2
};

/// Constant 'BIT_INDEX_ARM_LIGHT'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__BIT_INDEX_ARM_LIGHT = 3
};

/// Constant 'BIT_INDEX_LEG_LIGHT'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__BIT_INDEX_LEG_LIGHT = 4
};

/// Constant 'BIT_INDEX_WHEEL_LIGHT'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__BIT_INDEX_WHEEL_LIGHT = 5
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/VruSpecificExteriorLights in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
  ///   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   vam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE describes the status of the exterior light switches of a VRU.
  ///  *
  ///  * The value of each bit indicates the state of the switch, which commands the corresponding light.
  ///  * The bit corresponding to a specific light shall be set to 1, when the corresponding switch is turned on, either manually by the driver or VRU
  ///  * or automatically by a vehicle or VRU system:
  ///  * - 0 `unavailable`     - indicates no information available,
  ///  * - 1 `backFlashLight ` - indicates the status of the back flash light,
  ///  * - 2 `helmetLight`     - indicates the status of the helmet light,
  ///  * - 3 `armLight`        - indicates the status of the arm light,
  ///  * - 4 `legLight`        - indicates the status of the leg light,
  ///  * - 5 `wheelLight`      - indicates the status of the wheel light.
  ///  * - Bits 6 to 8         - are reserved for future use.
  ///  * The bit values do not indicate if the corresponding lamps are alight or not.
  ///  * If  VRU is not equipped with a certain light or if the light switch status information is not available, the corresponding bit shall be set to 0.
  ///  *
  ///  * @category: VRU information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// VruSpecificExteriorLights ::= BIT STRING {
  ///     unavailable    (0),
  ///     backFlashLight (1),
  ///     helmetLight    (2),
  ///     armLight       (3),
  ///     legLight       (4),
  ///     wheelLight     (5)
  /// } (SIZE(8))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights.
typedef struct etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__Sequence
{
  etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_SPECIFIC_EXTERIOR_LIGHTS__STRUCT_H_
